-- =============================================
-- Author:		fid.Joko
-- Create date: 03.10.2013
-- Description:	Revert Invoice Payment ICS
-- =============================================
CREATE PROCEDURE [dbo].[SP_ICS_InsertReverseInvoice] 
	-- Add the parameters for the stored procedure here
	@processId BIGINT, 
	@INVOICE_NO VARCHAR(16)
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

	Begin Try
	BEGIN TRANSACTION IPPCSSP_ICS_InsertReverseInvoice
	DECLARE @sqlQuery AS VARCHAR(MAX),
		@function VARCHAR(10),
		@REVERSE_FLAG CHAR(1),
		@SupplierInvoiceNo VARCHAR(12);
	CREATE TABLE #ICS_FINISH(REVERSE_FLAG CHAR(1), SupplierInvoiceNo VARCHAR(12))
	
	SET @function = '53004';
	-- ============================================
	-- PHASE 1 : GET INVOICE_NO ICS PROCESS
	-- ============================================
	
	SET @sqlQuery = 'INSERT INTO #ICS_FINISH SELECT REVERSE_FLAG, SUPP_INV_NO FROM OPENQUERY([IPPCS_TO_ICS] , ''select * from tb_r_invoice_h where INV_NO = ' + CONVERT(VARCHAR, @INVOICE_NO) + ''')';
	EXEC (@sqlQuery);
	
	SELECT @REVERSE_FLAG=REVERSE_FLAG,
		@SupplierInvoiceNo=SupplierInvoiceNo
	FROM #ICS_FINISH
	
	EXEC sp_PutLog 
		'Get REVERSE_FLAG From Finished ICS Process'
		, 'System'
		, 'SP_ICS_InsertReverseInvoice'
		, @processId
		, 'MPCS00004INF'
		, ''
		, '5'
		, @function
		, 0
		
	INSERT INTO TB_T_LOCK
           ([FUNCTION_NO]
           ,[LOCK_REFF]
           ,[CREATED_BY]
           ,[CREATED_DT])
    VALUES
		(@function
		,@processId
		,'System'
		,GETDATE())
	
	-- ==============================================
	-- PHASE 2 : UPDATE Invoice Table
	-- ==============================================
	IF @REVERSE_FLAG = 'Y'
	BEGIN
		DELETE FROM TB_R_INV_H WHERE INV_NO=@INVOICE_NO
		DELETE FROM TB_R_INV_D WHERE INV_NO=@INVOICE_NO
		DELETE FROM TB_R_INV_TAX WHERE INVOICE_NO=@INVOICE_NO
		DELETE FROM TB_R_INV_GL_ACCOUNT WHERE INV_NO=@INVOICE_NO
		
		INSERT INTO TB_R_INV_UPLOAD
		SELECT * FROM TB_R_INV_UPLOAD_LOG WHERE SUPP_INV_NO=@SupplierInvoiceNo
		
		INSERT INTO TB_T_INV_GL_ACCOUNT
		SELECT * FROM TB_T_INV_GL_ACCOUNT_LOG WHERE SUPP_INVOICE_NO=@SupplierInvoiceNo
		
		DELETE FROM TB_R_INV_UPLOAD_LOG WHERE SUPP_INV_NO=@SupplierInvoiceNo
		DELETE FROM TB_T_INV_GL_ACCOUNT_LOG WHERE SUPP_INVOICE_NO=@SupplierInvoiceNo
		UPDATE TB_R_INV_UPLOAD SET
			IN_PROGRESS=NULL
		WHERE SUPP_INV_NO=@SupplierInvoiceNo
		
		UPDATE gr SET
			gr.STATUS_CD='-4',
			CHANGED_BY='SYSTEM',
			CHANGED_DT=GETDATE()
		FROM TB_R_INV_UPLOAD tu
		INNER JOIN TB_R_GR_IR gr ON gr.PO_NO=tu.PO_NO AND
							gr.PO_ITEM_NO=tu.PO_ITEM_NO AND
							gr.MAT_DOC_NO=tu.MAT_DOC_NO AND
							gr.ITEM_NO=tu.MAT_DOC_ITEM AND
							gr.COMP_PRICE_CD=tu.COMP_PRICE_CD
		WHERE tu.SUPP_INV_NO=@SupplierInvoiceNo
	END
	
	EXEC sp_PutLog 
		'Update Invoice Table'
		, 'System'
		, 'SP_ICS_InsertReverseInvoice'
		, @processId
		, 'MPCS00004INF'
		, ''
		, '5'
		, @function
		, 0
	
	DELETE FROM [TB_T_LOCK]
	WHERE
		[FUNCTION_NO] = @function
        AND [LOCK_REFF] = @processId;

	---=== Store to TB_R_ICS_QUEUE modified by Rahmat 2013.10.31
	UPDATE TB_R_ICS_QUEUE
	SET
		PROCESS_STATUS = 2,
		CHANGED_BY = 'SYSTEM',
		CHANGED_DT = GETDATE()
	WHERE
		IPPCS_MODUL = '5'
		AND IPPCS_FUNCTION = @function
		AND PROCESS_ID = @processId
		AND PROCESS_STATUS = '1'
	
	--DECLARE @Email varchar(1000),
	--	@body VARCHAR(MAX)
	--SELECT @Email=m.EMAIL
	--FROM TB_R_INV_H h
	--inner join [10.16.25.112\SQLEXPRESS].OPENLDAP.dbo.TB_M_EMPLOYEE m ON h.CREATED_BY=m.USERNAME
	--WHERE INV_NO=@INVOICE_NO
	
	--SET @body = 'Dear Mr./Mrs.,' + CHAR(13) + CHAR(10) + CHAR(13) + CHAR(10) +
	--			'Please be informed that your Invoice with Supplier Invoice No ' + CONVERT(VARCHAR,@SupplierInvoiceNo) + ' is reverted with Invoice Document No ' + CONVERT(VARCHAR,@INVOICE_NO) +  CHAR(13) + CHAR(10) + CHAR(13) + CHAR(10) +
	--			'This email is autogenerated by system, please do not reply' +  CHAR(13) + CHAR(10) + CHAR(13) + CHAR(10) +
	--			'Thank you for your attention '
			
	--IF @Email <> ''
	--BEGIN	
	--	EXEC msdb.dbo.sp_send_dbmail
	--		@profile_name = 'NotificationAgent',
	--		@body = @body,
	--		@recipients = @Email,
	--		@copy_recipients = 'supplierportal8@toyota.co.id;vandy.cahyadi@toyota.co.id',
	--		@subject = '[IPPCS] Post Invoice Notification' ;
	--END
	
	Commit TRANSACTION IPPCSSP_ICS_InsertReverseInvoice		
	End Try
	Begin Catch
		SELECT ERROR_MESSAGE()
		Rollback Transaction IPPCSSP_ICS_InsertReverseInvoice;
	End Catch
END

